﻿@model IEnumerable<ExploreApilkasiCuti.Models.PengajuanCuti>

@{
    ViewBag.Title = "List Outstanding Approval";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<style>
    .content-table {
        border-collapse: collapse;
        margin: 25px 0;
        min-width: 1000px;
        box-shadow: 0 0 20px rgba(0, 0, 0, 0.15);
        width: 100%;
    }

    /* if the browser window is at least 800px-s wide: */
    @@media screen and (min-width: 800px) {
        table {
            width: 90%;
        }
    }

    /* if the browser window is at least 1000px-s wide: */
    @@media screen and (min-width: 1000px) {
        table {
            width: 80%;
        }
    }

    .content-table thead tr {
        background-color: #10ad21;
        color: #ffffff;
        text-align: left;
    }

    .content-table tr, td {
        border: solid black 0.5px;
    }

    .content-table th, td {
        padding: 12px 10px;
        border: solid black 0.5px;
    }

    #dataMasterJabatan_filter .iconSearch {
        float: left;
        display: inline-block;
    }

    .help-block {
        color: red;
    }

    .has-error {
        color: red;
    }

    .form-group:hover .hint,
    input:focus ~ div {
        opacity: 1;
    }

    /* hidden by default */
    .hint {
        content: "asd";
        opacity: 0;
        background: #EEE;
        position: absolute;
        top: 170px;
        left: 269px;
        padding: 7px;
        border: solid 1px #CCC;
        font-size: 12px;
        font-weight: bold;
        color: #555;
        border-radius: 0 7px 7px 0;
        transition: opacity 0.3s;
        box-shadow: inset 0px 4px 4px rgba(0, 0, 0, 0.05);
    }

    .grid {
        display: grid;
        grid-column-gap: 1rem;
        grid-auto-flow: column;
        margin: 0 0 0 0;
    }

    @*.grid > div {
        min-width: 10px;
    }

    *@

    body {
        margin: 1rem;
    }
</style>

@section HeadLibrary{
    <meta content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" name="viewport">
    <link rel="stylesheet" href="~/AdminLTE/plugins/fontawesome-free/css/all.min.css">
    <!-- Ionicons -->
    <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
    <!-- DataTables -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <!-- Toast-->
    <link rel="stylesheet" href="~/AdminLTE/plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css" />
    <link rel="stylesheet" href="~/AdminLTE/plugins/toastr/toastr.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="~/AdminLTE/dist/css/adminlte.min.css">
    <!-- Datepicker-->
    <link rel="stylesheet" href="~/AdminLTE/plugins/bootstrap-datepicker/css/bootstrap-datepicker.min.css">
    <!-- Google Font: Source Sans Pro -->
    @*    <link href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700" rel="stylesheet">
    *@    <!-- Select2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
}

<div class="card" id="approvalPengajuanHeader">
    <div class="card-header">
        <h2>List Outstanding Approval</h2>
    </div>
    <div class="card-body">
        <div class="row">
            <div class="col-sm-12">
                <table id="dataListOutstandingApproval" class="table table-bordered table-striped" style="color:black">
                    <thead>
                        <tr>
                            <th>
                                No.
                            </th>
                            <th>
                                Nama Karyawan
                            </th>
                            <th>
                                ID Pengajuan
                            </th>
                            <th>
                                Tanggal Pengajuan
                            </th>
                            <th>
                                Durasi
                            </th>
                            <th>
                                Jenis Pengajuan
                            </th>
                            <th>
                                Keterangan
                            </th>
                            <th style="width:65px">
                                Action
                            </th>
                        </tr>
                    </thead>
                </table>
            </div>
        </div>
    </div>
</div>

<div class="card" id="approvalPengajuanDetail">
    <div class="card-header">
        <h2 id="headerAddSeeDtl">Outstanding Pengajuan No. @ViewBag.Id</h2>
    </div>
    <div class="card-body">
        <div class="col-sm-12">
            <div class="row justify-content-between">
                @*<a href="@Url.Action("Index", "ApprovalPengajuan")" class="btn btn-default">
                        <i class="nav-icon fas fa-chevron-left"></i>   Kembali
                    </a>*@
                <button type="button" class="btn btn-default" onclick="back_to_header()" id="btnBackToHeader">
                    <i class="nav-icon fas fa-chevron-left"></i>   Kembali
                </button>
                <div class="mt-3 col-md-12"></div>
            </div>
        </div>
        <div class="row">
            <div class="col-sm-12">
                <div class="card card-primary">
                    <form role="form" id="form-header">
                        <div class="card-body">
                            <div class="form-group" style="width:50%">
                                <label class="control-label">Nama Karyawan</label>
                                <input name="NamaKaryawan" placeholder="Nama Karyawan" id="NamaKaryawan" class="form-control" type="text" readonly>
                                <span class="help-block"></span>
                            </div>
                            <div class="form-group" style="width:50%">
                                <label class="control-label">Tanggal Pengajuan</label>
                                <input name="TglPengajuan" placeholder="Tanggal Pengajuan" id="TglPengajuan" class="form-control" type="text" readonly>
                                <span class="help-block"></span>
                            </div>
                            <div class="form-group" style="width:50%">
                                <label class="err-jenisCuti control-label">Jenis Pengajuan</label>
                                <input name="JenisCuti" placeholder="Jenis Pengajuan" id="JenisCuti" class="form-control" type="text" readonly>
                                <span id="spanJenisCuti" class="err-jenisCuti help-block"></span>
                            </div>
                            <div class="form-inline justify-content-between" style="width:50%">
                                <div class="form-group">
                                    <label class="control-label" style="padding-right:1em">Pilih Tanggal Cuti</label>
                                    <div class="input-group date form-group" id="datepicker">
                                        <input type="text" class="form-control" id="LeaveDatePicker" name="LeaveDatePicker" placeholder="Select days" hidden />
                                        @*<span class="input-group-addon"><i class="fa fa-calendar"></i><span class="count"></span></span>*@
                                        <span class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-secondary waves-effect waves-light"><i class="fa fa-calendar"></i></span>
                                    </div>
                                </div>
                                <div class="form-group">
                                    <label class="control-label" id="TotalDurasi" style="padding-right:1em">Total Durasi</label>
                                    <input class="form-control" id="TotalDurasiInput" type="text" readonly>
                                </div>
                                <span id="span_leave_day_input" class="help-block"></span>
                            </div>
                            <div class="form-group" style="width:50%">
                                <label class="control-label">Keterangan</label>
                                <textarea name="Keterangan" placeholder="Enter ..." id="Keterangan" class="form-control" type="text" rows="3" readonly></textarea>
                                <span class="help-block"></span>
                            </div>
                            <div class="form-group" style="width:50%" id="group-AlmSaatCuti">
                                <label class="control-label">Alamat Saat Cuti</label>
                                <textarea name="AlmSaatCuti" placeholder="Enter ..." id="AlmSaatCuti" class="form-control" type="text" rows="3" readonly></textarea>
                                <span class="help-block"></span>
                            </div>
                            <div class="form-group" style="width:50%" id="group-TelpSaatCuti">
                                <label class="control-label">Telp. Saat Cuti</label>
                                <input name="TelpSaatCuti" placeholder="No. Telepon" id="TelpSaatCuti" class="form-control" type="text" readonly>
                                <span class="help-block"></span>
                            </div>
                            <div class="form-group" style="width:50%" id="group-saveFile>
                                    <label class="control-label" id="labelSaveFile">Attachment</label>
                                    <div></div>
                                    <input name="nama_file" placeholder="Tidak Ada" id="nama_file" type="text" style="width:300px" disabled>
                                    <button type="button" class="btn btn-default" onclick="saveFile()" id="btnSaveFile">
                                        <i class="nav-icon fas fa-save"></i>   Download
                                    </button>
                            </div>
                            <div class="form-group" id="sendToApproval">
                                <label class="control-label" id="labelSendToApproval">Kirim Ke</label>
                                <div class="grid" style="width:75%" id="gridSendToApproval">
                                    <div class="form-group" style="width:100%" id="formIdApproval">
                                        <select name="IDApproval" id="IDApproval" class="form-control select2 IDApproval" style="width: 100%;">
                                        </select>
                                        <span id="spanIdApproval" class="err-idApproval help-block"></span>
                                    </div>
                                    <div class="form-group" style="width:100%" id="formIdKywApproval">
                                        <select name="IDKywApproval" id="IDKywApproval" class="form-control select2 IDKywApproval" style="width: 100%;">
                                        </select>
                                        <span id="spanIdKywApproval" class="err-idKywApproval help-block"></span>
                                    </div>
                                    <div class="form-group" style="width:100%" id="formDecision">
                                        <select name="Decision" id="Decision" class="form-control select2 Decision" style="width: 100%;">
                                        </select>
                                        <span id="spanDecision" class="err-decision help-block"></span>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group" style="width:50%">
                                <label class="control-label">Keterangan Approval</label>
                                <textarea name="KeteranganApproval" placeholder="Enter ..." id="KeteranganApproval" class="form-control" type="text" rows="3"></textarea>
                                <span class="help-block"></span>
                            </div>
                            <div class="form-group">
                                <button type="button" class="btn btn-default" onclick="add_update_data('ADD')" id="btnSubmitData">
                                    <i class="nav-icon fas fa-save"></i>   Submit Data
                                </button>
                            </div>
                            <!--<label class="col-md-12" style="color:red">*Klik Tab untuk pindah field.</label>-->
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

<div aria-live="polite" aria-atomic="true" style="position: relative; min-height: 200px;">
    <!-- Then put toasts within -->
    <div id="toastResult" class="toast" style="position: absolute; top: 0; right: 0;">
        <div class="toast-header">
            <i class="fa fa-check"></i>
            <strong class="mr-auto">Success</strong>
            <button type="button" class="ml-2 mb-1 close" data-dismiss="toast" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div class="toast-body">
            <h6 class="toast-body-header">Master Jabatan berhasil update.</h6>
        </div>
    </div>
</div>

@section BodyLibrary{
   <!-- DataTables -->
    <script src="~/AdminLTE/plugins/datatables/jquery.dataTables.min.js"></script>
    <script src="~/AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
    <script src="~/AdminLTE/plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
    <script src="~/AdminLTE/plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
    <!-- Toast-->
    <script src="~/AdminLTE/plugins/sweetalert2/sweetalert2.min.js"></script>
    <script src="~/AdminLTE/plugins/toastr/toastr.min.js"></script>
    <!-- AdminLTE App -->
    <script src="~/AdminLTE/dist/js/adminlte.min.js"></script>
    <!-- AdminLTE for demo purposes -->
    <script src="~/AdminLTE/dist/js/demo.js"></script>
    <!-- Select2 -->
    <script src="~/AdminLTE/plugins/select2/js/select2.full.min.js"></script>
    <!-- DataRender -->
    <script src="@Url.Content("~/AdminLTE/plugins/dataRender/dateTime.js")"></script>
    <!-- Datepicker -->
    <script src="~/AdminLTE/plugins/bootstrap-datepicker/js/bootstrap-datepicker.min.js"></script>
}

@section AdditionalScript{
    <script type="text/javascript">
        var approvalPengajuanTable;
        var finishStatus;
        var destination = '@ViewBag.Action';
        var tempId = '@Session["id_karyawan"]'; // prompt("ID Karyawan:", "");
        var masterPengajuanDetailTable;
        var listDataDtl = [];
        var listDateCollection = [];
        var dataPengajuan;
        var detailLinkFile = "";

        jQuery(document).ready(function ($) {
            $("#approvalPengajuanHeader").show();
            $("#approvalPengajuanDetail").hide();

            var idKaryawan = {
                "idKaryawan" : tempId
            };
            console.log(idKaryawan)
            approvalPengajuanTable = $("#dataListOutstandingApproval").DataTable({
                "responsive": false,
                "autoWidth": false,
                "ajax": {
                    "datatype": 'json',
                    "type": 'POST',
                    "url": '@Url.Action("LoadDataOutstandingApproval", "ApprovalPengajuan")',
                    "data": { idKaryawan: tempId }
                },
                "columns": [
                    { "data": "no_urut", "name": "no_urut" },
                    { "data": "nama", "name": "nama" },
                    { "data": "id_pengajuan", "name": "id_pengajuan" },
                    { "data": "tgl_pengajuan", "name": "tgl_pengajuan" },
                    { "data": "durasi", "name": "durasi" },
                    { "data": "nama_pengajuan", "name": "nama_pengajuan" },
                    { "data": "keterangan_pengajuan", "name": "keterangan_pengajuan" },
                    { "data": "action", "className": "text-center" },
                ]
            });

            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("CheckApprovalFinish", "ApprovalPengajuan")',
                type: 'POST',
                data: JSON.stringify({ "idKaryawan": tempId }),
                success: function (data) {
                    if (data.response.Code == '200') {
                        finishStatus = data.data;
                    } else {
                        toastr.warning(data.response.Message, 'Sorry!', { 'timeOut': 5000 });
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                }
            });

            @*if (finishStatus) {
                $("#labelSendToApproval").text("Decision");
                $("#formIdApproval").hide();
                $("#formIdKywApproval").hide();
                $("#gridSendToApproval").css("width", "25%");
            } else {
                $("#labelSendToApproval").text("Kirim Ke");
                $("#formIdApproval").show();
                $("#formIdKywApproval").show();
                $("#gridSendToApproval").css("width", "75%");
            }*@
        });

        function edit_pengajuan(rowId) {
            @*var url = '@Url.Action("PengajuanCutiPages", "PengajuanCuti", new { id = "rowId", destination = "Edit", finish = "finishStatus"})';//new { id = "rowId", action = "action" })';
            window.location.href = url.replace('rowId', rowId).replace('finishStatus', finishStatus);*@
            $("#approvalPengajuanHeader").hide();
            $("#approvalPengajuanDetail").show(100);
            loadDataDetailById("Edit", rowId);
            $("#headerAddSeeDtl").text("Outstanding Pengajuan No. " + rowId);
        }

        function detail_pengajuan(rowId) {
            @*var url = '@Url.Action("DetailOutstandingPengajuan", "ApprovalPengajuan", new { id = "rowId", destination = "Detail", finish = "finishStatus"})';//new { id = "rowId", action = "action" })';
            window.location.href = url.replace('rowId', rowId).replace('finishStatus', finishStatus);*@
            $("#approvalPengajuanHeader").hide();
            $("#approvalPengajuanDetail").show(100);
            loadDataDetailById("Detail", rowId)
            $("#headerAddSeeDtl").text("Outstanding Pengajuan No. " + rowId);
        }

        function loadDataDetailById(destination, rowId) {
            listDataDtl = [];
            listDateCollection = [];
            resetTextValue();
            var dataParam = {
                "idKaryawan": tempId,
                "idPengajuan": rowId
            };

            if (dataParam.idPengajuan.startsWith("DL")) {
                $('#group-AlmSaatCuti').hide();
                $('#group-TelpSaatCuti').hide();
            }

            if (finishStatus) {
                $("#labelSendToApproval").text("Decision");
                $("#formIdApproval").hide();
                $("#formIdKywApproval").hide();
                $("#gridSendToApproval").css("width", "25%");
            }

            if (destination == 'Edit' || destination == 'Detail') {
                detailLinkFile = "";
                $.ajax({
                    contentType: 'application/JSON; charset=utf-8',
                    url: '@Url.Action("GetDetailOutstandingApproval", "ApprovalPengajuan")',
                    type: 'POST',
                    data: JSON.stringify(dataParam),
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Get Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (data) {
                        Swal.close();
                        if (data.response.Code == '200') {
                            successInitData(data['data']);
                            loadDataSelect2();
                            unselect_select2();
                        } else {
                            toastr.warning('Gagal memuat data', 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                    }
                });
            }
        }

        function back_to_header() {
            $("#approvalPengajuanDetail").hide();
            $("#approvalPengajuanHeader").show(100);
        }

        function successInitData(data) {
            $('#NamaKaryawan').val(data[0].nama);
            $('#JenisCuti').val(data[0].nama_pengajuan);
            $('#TglPengajuan').val(data[0].tgl_pengajuan);
            $("#Keterangan").val(data[0].keterangan_pengajuan);
            $("#AlmSaatCuti").val(data[0].alamat_cuti);
            $("#TelpSaatCuti").val(data[0].notelp_cuti);
            $("#TotalDurasiInput").val(data[0].durasi + " hari");
            $('#nama_file').val(data[0].nama_file);
            if ($("#nama_file").val() == '') {
                $("#btnSaveFile").prop('disabled', true);
            }
            detailLinkFile = data[0].link_file;
            listDataDtl = data[0].details;
            for (var i = 0; i < listDataDtl.length; i++) {
                listDateCollection.push(listDataDtl[i].start_date.replace("T00:00:00", ""));
            }

            $(document).ready(function () {
                $('#datepicker').datepicker({
                    multidate: true,
                    format: "mm/dd/yyyy",
                    todayHighlight: true,
                    beforeShowDay: function () {
                        return false;
                    }
                });

                $("#datepicker").datepicker('setDates', listDateCollection);
            });

            dataPengajuan = {
                "id_pengajuan": data[0].id_pengajuan,
                "tgl_pengajuan": data[0].tgl_pengajuan,
                "id_karyawan": data[0].id_karyawan,
                "id_jenis_pengajuan": data[0].id_jenis_pengajuan,
                "durasi": data[0].durasi,
                "denda cuti": data[0].denda_cuti,
                "alamat_cuti": data[0].alamat_cuti,
                "notelp_cuti": data[0].notelp_cuti,
                "keterangan_pengajuan": data[0].keterangan_pengajuan,
                "approve_status": data[0].approve_status,
                "keterangan_approve": data[0].keterangan_approve,
                "created_by": data[0].created_by,
                "created_date": data[0].created_date,
                "details": listDataDtl
            }
        }

        function enableDisableTextInput(enables) {
            $("#JenisCuti").prop('disabled', enables);
            $("#Keterangan").attr('readonly', enables);
            $("#AlmSaatCuti").attr('readonly', enables);
            $("#TelpSaatCuti").attr('readonly', enables);
            $("#IDApproval").prop('disabled', enables);
            $("#IDKywApproval").prop('disabled', enables);
        }

        function resetTextValue() {
            $("#Keterangan").val("");
            $("#IDApproval").val("").text("");
            $("#IDKywApproval").val("").text("");
        }

        function loadDataDetailTable(destination) {
            if (destination == "Detail") {
                if (!$.fn.DataTable.isDataTable('#dataPengajuanCutiDetail')) {
                    jQuery(document).ready(function ($) {
                        masterPengajuanDetailTable = $("#dataPengajuanCutiDetail").DataTable({
                            "autoWidth": false,
                            "responsive": true,
                            "ajax": {
                                "datatype": 'json',
                                "url": '@Url.Action("GetDataDetailPengajuanById", "PengajuanCuti")/' + '@ViewBag.Id' + '?destination=' + destination,//, new { id = @ViewBag.Id, destination = "Detail" })',
                                "type": 'POST',
                        @*"data": JSON.stringify({"id": '@ViewBag.Id'})*@
                            },
                            "columns": [
                                { "data": "no", "name": "no" },
                                { "data": "start_date", "name": "start_date" },
                                { "data": "end_date", "name": "end_date" },
                                { "data": "durasi", "name": "durasi" }
                            ]
                        });
                    });
                }
            }
        }

        function loadDataDetail(destination) {
            destination == "Detail" ? $("#btnAddDtl").hide() : $("#btnAddDtl").show();
            destination == "Detail" ? $("#btnSubmitData").hide() : $("#btnSubmitData").show();
        }

        function getDataKirimKe() {
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetSpecificDataLogApproval", "MasterLogApproval")',
                type: 'POST',
                data: JSON.stringify({ "idPengajuan": '@ViewBag.Id'}),
                success: function (data) {
                    if (data.response.Code == '200') {
                        if (data.data.length > 0) {
                            $("#IDApproval").empty().append($("<option/>").val(data.data[0].id_approval).text(data.data[0].nama_approval)).val(data.data[0].id_approval);
                            $("#IDKywApproval").empty().append($("<option/>").val(data.data[0].approved_by).text(data.data[0].nama_karyawan_approval)).val(data.data[0].approved_by);
                        }
                    } else {
                        var s = "<option value='-1'></option>";
                        $("#IDApproval").html(s);
                        $("#IDKywApproval").html(s);
                        toastr.warning('Gagal memuat data Log Approval', 'Sorry!', { 'timeOut': 5000 });
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        function getDataJenisCutiById(rowId) {
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetDataByID", "MasterJenisPengajuan")',
                type: 'POST',
                data: JSON.stringify({ "id": rowId}),
                success: function (data) {
                    if (data.metaData.code == '200') {
                        $("#JenisCuti").empty().append($("<option/>").val(data.response[0].id_jenis_pengajuan).text(data.response[0].nama_pengajuan)).val(data.response[0].id_jenis_pengajuan);
                    } else {
                        var s = "<option value='-1'></option>";
                        $("#CutiBulanan").html(s);
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error('Gagal memuat data', 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        function setTanggalPengajuan() {
            var today = new Date();
            var month = today.getMonth() + 1;
            var day = today.getDate();
            var currentDate = (('' + month).length < 2 ? '0' : '') + month +
                            '-' + (('' + day).length < 2 ? '0' : '') + day +
                            '-' + today.getFullYear();
            $('#TglPengajuan').val(currentDate);
        }

        function show_modal_insertupdatedetail(action) {
            save_method = action;
            if (action == 'ADD') {
                document.getElementById("form-insertupdatedetail").reset();
                $("#insertUpdateDetailModal").text("Tambah Tanggal Cuti");
            } else if (action == 'EDIT') {
                $("#insertUpdateDetailModal").text("Ubah Tanggal Cuti");
            }
            $('.form-group').removeClass('has-error');
            $(".help-block").empty();
            $("#modal_form_insertupdatedetail").modal('show');
        }
        @*
        function loadDataSelect2() {
            $('#IDApproval').select2({
                autoWidth: false,
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih ID Approval -',
                width: '100%',
                theme: 'bootstrap4',
                ajax: {
                    url: '@Url.Action("GetDatatableAll", "MasterApproval")',
                    type: 'POST',
                    dataType: 'json',
                    delay: 250,
                    processResults: function (data) {
                        return {
                            results: $.map(data['data'], function (item) {
                                return {
                                    text: item.nama_approval,
                                    id: item.id_approval
                                }
                            })
                        };
                    }
                }
            });

            $('#IDApproval').on('select2:select', function (e) {
                var idApproval = {
                    "id": $("#IDApproval option:selected").val()
                };
                console.log(idApproval);

                $('#IDKywApproval').select2({
                    autoWidth: false,
                    multiple: false,
                    allowClear: true,
                    placeholder: '- Pilih ID Karyawan Approval -',
                    width: '100%',
                    theme: 'bootstrap4',
                    ajax: {
                        contentType: 'application/JSON; charset=utf-8',
                        url: '@Url.Action("GetDataByIdApproval", "MasterKaryawanApproval")',
                        data: JSON.stringify(idApproval),
                        type: 'POST',
                        dataType: 'json',
                        delay: 250,
                        processResults: function (data) {
                            return {
                                results: $.map(data['data'], function (item) {
                                    return {
                                        text: item.nama,
                                        id: item.id_karyawan,
                                        data: item
                                    }
                                })
                            };
                        }
                    }
                });
            });

            $('#IDKywApproval').select2({
                autoWidth: false,
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih ID Karyawan Approval -',
                width: '100%',
                theme: 'bootstrap4',
            });

            $('#IDApproval').on('select2:unselect', function () {
                $('#IDKywApproval').empty();
                $('#IDKywApproval').select2({
                    autoWidth: false,
                    multiple: false,
                    allowClear: true,
                    placeholder: '- Pilih ID Karyawan Approval -',
                    width: '100%',
                    theme: 'bootstrap4',
                    data: null
                });
            });

            var dataArray = [
                {id : 'Approve', text : 'Approve'},
                {id : 'Forward', text : 'Forward'},
                {id : 'Reject', text : 'Reject'}
            ];

            $('#Decision').select2({
                autoWidth: false,
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih Keputusan -',
                width: '100%',
                theme: 'bootstrap4',
                data: dataArray
            });

            $('#Decision').on('select2:select', function (e) {
                var decision = $("#Decision option:selected").val();
                console.log(decision);

                if (!finishStatus || (finishStatus && decision == "Forward")) {
                    $("#labelSendToApproval").text("Kirim Ke");
                    $("#formIdApproval").show();
                    $("#formIdKywApproval").show();
                    $("#gridSendToApproval").css("width", "75%");
                } else {
                    $("#labelSendToApproval").text("Decision");
                    $("#formIdApproval").hide();
                    $("#formIdKywApproval").hide();
                    $("#gridSendToApproval").css("width", "25%");
                }
            });
           
        }
        *@

        function unselect_select2() {


            var newOption = new Option("", "", true, true);
            var newOption2 = new Option("", "", true, true);
            // Append it to the select
            $('#JenisCuti').append(newOption).trigger('change');
            $('#IDApproval').append(newOption2).trigger('change');

        }
        function loadDataSelect2() {
            var idApproval = "";
            var listDetailPct = [];

            $.ajax({
                url: '@Url.Action("GetDatatableAll", "MasterApproval")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data['data'], function (item) {
                            if (item.status == "Aktif") {
                                return {
                                    text: item.nama_approval,
                                    id: item.id_approval
                                }
                            }
                        })
                    };
                }
            }).then(
                function (response) {
                    $('#IDApproval').select2({
                        multiple: false,
                        allowClear: true,
                        placeholder: '- Pilih ID Approval -',
                        width: '100%',
                        theme: 'bootstrap4',
                        data: $.map(response.data, function (item) {
                            if (item.status == "Aktif") {
                                return {
                                    text: item.nama_approval,
                                    id: item.id_approval
                                }
                            }
                        })
                    });
                }
            );

            $('#IDApproval').on('select2:select', function (e) {
                var idApproval = {
                    "id": $("#IDApproval option:selected").val()
                };
                $('#IDKywApproval').empty();
                $.ajax({
                    contentType: 'application/JSON; charset=utf-8',
                    url: '@Url.Action("GetDataByIdApproval", "MasterKaryawanApproval")',
                    data: JSON.stringify(idApproval),
                    type: 'POST',
                    dataType: 'json',
                    delay: 250,
                    processResults: function (data) {
                        return {
                            results: $.map(data['data'], function (item) {
                                return {
                                    text: item.nama,
                                    id: item.id_karyawan,
                                    data: item
                                }
                            })
                        };
                    }
                }).then(
                    function (response) {
                        $('#IDKywApproval').select2({
                            multiple: false,
                            allowClear: true,
                            placeholder: '- Pilih ID Karyawan Approval -',
                            width: '100%',
                            theme: 'bootstrap4',
                            data: $.map(response.data, function (item) {
                                    return {
                                        text: item.nama,
                                        id: item.id_karyawan,
                                        data: item
                                    }
                            })
                        });
                    }
                );

                var newOption = new Option("", "", true, true);
                $('#IDKywApproval').append(newOption).trigger('change');
            });

            $('#IDKywApproval').select2({
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih ID Karyawan Approval -',
                width: '100%',
                theme: 'bootstrap4',
            });
            $('#IDApproval').select2({
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih ID Approval -',
                width: '100%',
                theme: 'bootstrap4',
            });


            $('#IDApproval').on('select2:unselect', function () {
                $('#IDKywApproval').empty();
                $('#IDKywApproval').select2({
                    multiple: false,
                    allowClear: true,
                    placeholder: '- Pilih ID Karyawan Approval -',
                    width: '100%',
                    theme: 'bootstrap4',
                    data: null
                });
            });

            

            var dataArray = [
                { id: 'Approve', text: 'Approve' },
                { id: 'Forward', text: 'Forward' },
                { id: 'Reject', text: 'Reject' }
            ];

            $('#Decision').select2({
                autoWidth: false,
                multiple: false,
                allowClear: true,
                placeholder: '- Pilih Keputusan -',
                width: '100%',
                theme: 'bootstrap4',
                data: dataArray
            });

            $('#Decision').on('select2:select', function (e) {
                var decision = $("#Decision option:selected").val();
                console.log(decision);

                if (!finishStatus || (finishStatus && decision == "Forward")) {
                    $("#labelSendToApproval").text("Kirim Ke");
                    $("#formIdApproval").show();
                    $("#formIdKywApproval").show();
                    $("#gridSendToApproval").css("width", "75%");
                } else {
                    $("#labelSendToApproval").text("Decision");
                    $("#formIdApproval").hide();
                    $("#formIdKywApproval").hide();
                    $("#gridSendToApproval").css("width", "25%");
                }
            });
        }
        function getNamaKaryawanById() {
             $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetDataByIdKaryawan", "MasterKaryawan")',
                type: 'POST',
                data: JSON.stringify({ "id": tempId }),
                success: function (data) {
                    Swal.close();
                    if (data.response.code == '200') {
                        $("#NamaKaryawan").val(data['data'][0].nama);
                    } else {
                        toastr.warning("Gagal memuat nama karyawan", "Sorry!", { "timeOut" : 5000});
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error("Gagal memuat data.", 'Failed!', { "timeOut": 5000 });
                }
             });
        }

        function delete_pengajuandtl(rowId) {
            if (rowId != null) {
                Swal.fire({
                    title: 'Konfirmasi',
                    text: "Apakah Anda yakin akan menghapus data ini?",
                    type: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Hapus Data',
                    confirmButtonClass: 'btn btn-primary',
                    cancelButtonClass: 'btn btn-danger ml-1',
                    buttonsStyling: false,
                    allowOutsideClick: () => !Swal.isLoading()
                }).then((result) => {
                    if (result.value == true) {
                        listDataDtl.splice(rowId, 1);
                        masterPengajuanDetailTable.clear();
                        masterPengajuanDetailTable.rows.add(listDataDtl).draw();
                    }
                });
            }
        }

        function edit_pengajuandtl(rowId) {
            save_method = "EDIT";
            rowData = rowId;
            $('.form-group').removeClass('has-error');
            $(".help-block").empty();

            if (rowId != null) {
                $("#StartDate").val(masterPengajuanDetailTable.row(rowId).data().start_date);
                $("#EndDate").val(masterPengajuanDetailTable.row(rowId).data().end_date);
                $("#Waktu").val(masterPengajuanDetailTable.row(rowId).data().durasi);

                $("#insertUpdateDetailModal").text("Ubah Tanggal Cuti");
                $("#modal_form_insertupdatedetail").modal('show');
            }
        }

        function add_update_data(save_method) {
            $(".form-group").removeClass('has-error');
            $(".help-block").empty();
            var validate = true;
            var sumDtlDuration = 0;
            $.each(listDataDtl, function () { return sumDtlDuration += parseFloat(this.durasi) || 0;});

            if ($("#NamaKaryawan").val() == "" || !$("#NamaKaryawan").val().replace(/\s/g, '').length) {
                $('#NamaKaryawan').parent().addClass('has-error');
                $('#NamaKaryawan').next().text('Nama Karyawan harus diisi');
                validate = false;
            }
            if ($("#TglPengajuan").val() == "" || !$("#TglPengajuan").val().replace(/\s/g, '').length) {
                $('#TglPengajuan').parent().addClass('has-error');
                $('#TglPengajuan').next().text('Tanggal Pengajuan harus diisi');
                validate = false;
            }
            if ($("#JenisCuti").val() == null) {
                $('#spanJenisCuti').text('Jenis Cuti harus diisi');
                $('.err-jenisCuti').css('color: red');
                validate = false;
            }
            @*if ($("#Keterangan").val() == "" || !$("#Keterangan").val().replace(/\s/g, '').length) {
                $('#Keterangan').parent().parent().parent().addClass('has-error');
                $('#Keterangan').next().text('Keterangan harus diisi');
                validate = false;
            }*@
            if (dataPengajuan.id_pengajuan.startsWith("CT")) {
                if ($("#AlmSaatCuti").val() == "" || !$("#AlmSaatCuti").val().replace(/\s/g, '').length) {
                    $('#AlmSaatCuti').parent().addClass('has-error');
                    $('#AlmSaatCuti').next().text('Alamat Saat Cuti harus diisi');
                    validate = false;
                }
                if ($("#TelpSaatCuti").val() == "" || !$("#TelpSaatCuti").val().replace(/\s/g, '').length) {
                    $('#TelpSaatCuti').parent().addClass('has-error');
                    $('#TelpSaatCuti').next().text('No. Telp. Saat Cuti harus diisi');
                    validate = false;
                }
            }
            if (!finishStatus && $("#Decision").val() != "Approve") {
                if ($("#IDApproval").val() == null) {
                    $('#spanIdApproval').text('ID Approval harus diisi');
                    $('.err-idApproval').css('color: red');
                    validate = false;
                }
                if ($("#IDKywApproval").val() == null) {
                    $('#spanIdKywApproval').text('ID Karyawan Approval harus diisi');
                    $('.err-idKywApproval').css('color: red');
                    validate = false;
                }
            }
            if ($("#Decision").val() == null) {
                $('#spanDecision').text('Decision harus diisi');
                $('.err-decision').css('color: red');
                validate = false;
            }
            if (!listDataDtl.length) {
                toastr.warning("Detail tidak boleh kosong.", "Sorry!", { "timeOut" : 5000});
                validate = false;
            }
            if (!validate) return;

            dataPengajuan.keterangan_approve = $("#KeteranganApproval").val();
            dataPengajuan.approve_status = $("#Decision").val();
            var submittedData = {
                "id_karyawan_approval": tempId,
                "pengajuan": dataPengajuan,
                "new_id_approval": $("#IDApproval").val(),
                "new_approved_by": $("#IDKywApproval").val()
            };

            $.ajax({
                url: '@Url.Content("~/ApprovalPengajuan/SubmitApprovalPengajuan")',
                contentType: 'application/JSON; charset=utf-8',
                type: 'POST',
                dataType: 'json',
                data: JSON.stringify(submittedData),
                beforeSend: function () {
                    Swal.fire({
                        title: 'Processing...',
                        html: "Saving Data.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (data) {
                    Swal.close();
                    if (data.response.Code == "200") {
                       @* $("#modal_form_insertupdate").modal('hide');
                        reload_table();*@
                        toastr.success("Status Pengajuan Cuti dengan ID Pengajuan <strong>" + dataPengajuan.id_pengajuan + "</strong> berhasil diubah", "Success!", { "timeOut": 5000 });
                        setTimeout(function () {
                            approvalPengajuanTable.ajax.reload(null, false);
                            $("#approvalPengajuanHeader").show(100);
                            $("#approvalPengajuanDetail").hide();
                        }, 1000);
                    } else {
                        toastr.warning(data.response.Message, "Sorry!", { "timeOut": 5000 });
                        $("#labelSendToApproval").text("Kirim Ke");
                        $("#formIdApproval").show();
                        $("#formIdKywApproval").show();
                        $("#gridSendToApproval").css("width", "75%");
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    Swal.close();
                    $('#btnSaveAddUpdate').text('Save'); //change button text
                    $('#btnSaveAddUpdate').attr('disabled', false);
                    toastr.error("Gagal ubah status data pengajuan.", 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        function validateDataDtl(item, rowData) {
            if (save_method == "ADD") {
                for (var i = 0; i < listDataDtl.length; i++) {
                    if (listDataDtl[i].start_date == item.start_date) return "Tanggal Mulai sudah ada";
                    if (listDataDtl[i].end_date == item.end_date) return "Tanggal Selesai sudah ada";
                }
            } else if (save_method == "EDIT") {
                for (var i = 0; i < listDataDtl.length; i++) {
                    if (i != rowData) {
                        if (listDataDtl[i].start_date == item.start_date) return "Tanggal Mulai sudah ada";
                        if (listDataDtl[i].end_date == item.end_date) return "Tanggal Selesai sudah ada";
                    }
                }
            }
            return "Success";
        }

        function add_update_detail() {
            var validate = "Success";
            var _validate = true;
            var itemDtl = {
                "start_date": $("#StartDate").val(),
                "end_date": $("#EndDate").val(),
                "durasi": $("#Waktu").val()
            };

            $('.form-group').removeClass('has-error');
            $(".help-block").empty();

            if ($("#StartDate").val() == "" || !$("#StartDate").val().replace(/\s/g, '').length) {
                $('#StartDate').parent().addClass('has-error');
                $('#span_start_date').text('Tanggal Mulai harus diisi');
                _validate = false;
            }
            if ($("#EndDate").val() == "" || !$("#EndDate").val().replace(/\s/g, '').length) {
                $('#EndDate').parent().addClass('has-error');
                $('#span_end_date').text('Tanggal Selesai harus diisi');
                _validate = false;
            }
            if ($("#Waktu").val() == "" || !$("#Waktu").val().replace(/\s/g, '').length) {
                $('#Waktu').parent().addClass('has-error');
                $('#Waktu').next().text('Waktu harus diisi');
                _validate = false;
            }
            if (!_validate) return;

            if (save_method == "ADD") {
                if (listDataDtl.length > 0) validate = validateDataDtl(itemDtl, 0);

                if (validate == "Success") {
                    listDataDtl.push(itemDtl);

                }
                else {
                    $("#modal_form_insertupdatedetail").modal('hide');
                    return toastr.warning("Gagal menambahkan data: " + validate, "Sorry!", { "timeOut": 5000 });
                }
            }
            else if (save_method == "EDIT") {
                if (listDataDtl.length > 0) validate = validateDataDtl(itemDtl, rowData);

                if (validate == "Success") {
                    listDataDtl[rowData].start_date = itemDtl.start_date;
                    listDataDtl[rowData].end_date = itemDtl.end_date;
                    listDataDtl[rowData].durasi = itemDtl.durasi;
                }
                else {
                    $("#modal_form_insertupdatedetail").modal('hide');
                    return toastr.warning("Gagal menambahkan data: " + validate, "Sorry!", { "timeOut": 5000 });
                }
            }

            masterPengajuanDetailTable.clear();
            masterPengajuanDetailTable.rows.add(listDataDtl).draw();
            $("#modal_form_insertupdatedetail").modal('hide');
        }
        function saveFile() {
            window.open("https://116.254.101.104/CutiInta/" + detailLinkFile, '_blank');
        }
    </script>
}